----------------------------------------------
-- MSS copyright 1999-2000
-- VHDL code for generic adders
-- Primary project: channel unit v3
-- Author: Alain Zarembowitch / MSS
-- Edit date: 5-99
-- Edit date: 7-27-00
-- Revision: 3
--
-- Changes in Rev 3:
--		replaced previous version (Carry ahead rev1, Xilinx Macro rev2)
--		with generic VHDL code as synthesis tools are good enough to synthesize this high level statement
----------------------------------------------
-----------------------------------------------------------------
-- 8 bit adder 
-----------------------------------------------------------------
Library ieee;
Use ieee.std_logic_1164.all;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
entity fcadd8_2 is
	port (
		ci: 	in std_logic;
		a7,a6,a5,a4,a3,a2,a1,a0:	in std_logic;
		b7,b6,b5,b4,b3,b2,b1,b0:	in std_logic;
		sum7,sum6,sum5,sum4,sum3,sum2,sum1,sum0: out std_logic;
		co: out std_logic);
end fcadd8_2;

architecture archfcadd8_2 of fcadd8_2 is

signal summer, ain, bin: std_logic_vector(8 downto 0);
signal cin: std_logic_vector(8 downto 0);

		
begin

-- for simulation purposes
--cin(8 downto 1) <= (others => '0');
--cin(0) <= ci;
--summer <= ain + bin + cin;
summer <= ain + bin + ci;

ain(0) <=a0;
ain(1) <=a1;
ain(2) <=a2;
ain(3) <=a3;
ain(4) <=a4;
ain(5) <=a5;
ain(6) <=a6;
ain(7) <=a7;
ain(8) <='0';

bin(0) <= b0;
bin(1) <= b1;
bin(2) <= b2;
bin(3) <= b3;
bin(4) <= b4;
bin(5) <= b5;
bin(6) <= b6;
bin(7) <= b7;
bin(8) <= '0'; 

sum0 <= summer(0);
sum1 <= summer(1);
sum2 <= summer(2);
sum3 <= summer(3);
sum4 <= summer(4);
sum5 <= summer(5);
sum6 <= summer(6);
sum7 <= summer(7);

co <= summer(8);

end archfcadd8_2;


